package dev.flyfish.framework.backup.scheduler;

import lombok.AllArgsConstructor;
import lombok.Data;

import java.util.List;

/**
 * 备份索引
 *
 * @author wangyu
 */
@Data
public class BackupIndex {

    // 备份uuid，与数据库对应
    private String id;

    // 创建时间
    private String createTime;

    // 备份条目
    private List<BackupItem> items;

    /**
     * 备份条目
     */
    @Data
    public static class BackupItem {

        // 集合名称
        private String collection;

        // 文件路径
        private String path;

        // 备份大小
        private String size;
    }

    /**
     * 备份内容
     */
    @Data
    @AllArgsConstructor
    public static class BackupContent {

        // 集合名称
        private String collection;

        // 内容
        private byte[] content;
    }
}
