package dev.flyfish.framework.utils;

import org.apache.commons.lang3.StringUtils;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * 字符串格式化工具类
 *
 * @author wangyu
 */
public abstract class StringFormats {

    // 匹配表达式
    private static final Pattern pattern = Pattern.compile("[A-Z]([a-z\\d]+)?");

    /**
     * 驼峰转连字符
     *
     * @param value 字符串
     * @return 结果
     */
    public static String camel2Line(String value) {
        if (StringUtils.isBlank(value)) {
            return value;
        }
        StringBuilder sb = new StringBuilder();
        Matcher matcher = pattern.matcher(value);
        while (matcher.find()) {
            String word = matcher.group();
            sb.append(word.toLowerCase());
            sb.append(matcher.end() == value.length() ? "" : "-");
        }
        return sb.toString();
    }
}
