package dev.flyfish.framework.auditor;

import dev.flyfish.framework.domain.base.Domain;
import reactor.core.publisher.Mono;

/**
 * 异步的对bean进行后置审查
 *
 * @param <T> 泛型
 */
public interface ReactiveBeanPoster<T extends Domain> {

    /**
     * 对入库的实体进行审查，并执行额外功能
     *
     * @param data 原数据
     */
    Mono<T> post(T data);
}
