package dev.flyfish.framework.query.chain;

import dev.flyfish.framework.query.NamedQueryChain;
import dev.flyfish.framework.query.QueryCondition;

/**
 * 默认按名称的查询链实现
 *
 * @author wangyu
 */
public class DefaultNamedQueryChain extends DefaultQueryChain<NamedQueryChain, String> implements NamedQueryChain {

    /**
     * 以且连接下一个字段
     *
     * @param column 列
     * @return 查询条件
     */
    @Override
    public QueryCondition<NamedQueryChain> and(String column) {
        and();
        return createCondition(column);
    }

    /**
     * 以或连接下一个字段
     *
     * @param column 列
     * @return 查询条件
     */
    @Override
    public QueryCondition<NamedQueryChain> or(String column) {
        or();
        return createCondition(column);
    }

}
