package dev.flyfish.framework.domain.po;

import dev.flyfish.framework.domain.tree.TreeDomain;
import dev.flyfish.framework.enums.NamedEnum;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.Getter;
import org.springframework.data.mongodb.core.mapping.Document;
import org.springframework.data.relational.core.mapping.Table;

/**
 * 权限
 *
 * @author wangyu
 */
@Document("permissions")
@Table("t_permission")
@Data
public class Permission extends TreeDomain<Permission> {

    public static final Permission ROOT;

    static {
        ROOT = new Permission();
        ROOT.setId("0");
        ROOT.setDepth(0);
    }

    /**
     * 权限类型，分为路由和动作
     */
    private Type type = Type.ROUTE;
    /**
     * 是否是管理员权限
     */
    private boolean admin;
    /**
     * 是否是叶子节点
     */
    private Boolean leaf;

    @Getter
    @AllArgsConstructor
    public enum Type implements NamedEnum {

        ROUTE("路由"), ACTION("动作");

        private final String name;
    }
}
