package dev.flyfish.framework.r2dbc.metadata.reference;

import dev.flyfish.framework.annotations.Property;
import dev.flyfish.framework.r2dbc.metadata.reference.field.FieldAccessor;
import dev.flyfish.framework.relational.mapping.Association;
import lombok.AllArgsConstructor;
import lombok.Data;
import org.springframework.data.mapping.PersistentEntity;

/**
 * 多对多关系
 *
 * @author wangyu
 */
@Data
@Property("多对多关系")
@AllArgsConstructor
public class R2dbcRelation {

    @Property("关联实体类")
    private PersistentEntity<?, ?> entity;

    @Property("关系表名称")
    private String tableName;

    @Property("关系表本实体id字段")
    private String field;

    @Property("关系表外部实体id字段")
    private String foreignField;

    @Property("目标值访问器")
    private FieldAccessor accessor;

    public static R2dbcRelation of(PersistentEntity<?, ?> entity, Association association, FieldAccessor accessor) {
        return new R2dbcRelation(entity, association.relationTable(), association.field(), association.foreignField(), accessor);
    }
}
