package dev.flyfish.framework.file.utils;

import dev.flyfish.framework.file.enums.MediaTypes;
import org.apache.commons.lang3.StringUtils;
import org.springframework.http.ContentDisposition;
import org.springframework.http.HttpHeaders;
import org.springframework.http.ZeroCopyHttpOutputMessage;
import org.springframework.http.server.reactive.ServerHttpResponse;
import reactor.core.publisher.Mono;

import java.nio.file.Path;
import java.nio.file.Paths;

public abstract class DownloadUtils {

    public static Mono<Void> download(String path, ServerHttpResponse response) {
        ZeroCopyHttpOutputMessage zeroCopyResponse = (ZeroCopyHttpOutputMessage) response;
        HttpHeaders headers = zeroCopyResponse.getHeaders();
        headers.setContentType(MediaTypes.getMediaType(path));
        headers.setContentDisposition(ContentDisposition.builder("attachment")
                .filename(StringUtils.substringAfterLast(path, "/"))
                .build());
        Path file = Paths.get(path);
        return zeroCopyResponse.writeWith(file, 0, file.toFile().length());
    }
}
